using System.Collections;
using System.Collections.Generic;
using UnityEngine;

[RequireComponent(typeof(Animator))]
[RequireComponent(typeof(Controller))]
public class BehindBackScript : MonoBehaviour
{
    private Animator animatorController;
    private Controller controller;
    private bool usingAxis;

    // Use this for initialization
    void Start ()
    {
        //fazer dinamico
        controller = GetComponent<Controller>();
        animatorController = GetComponent<Animator>();
        usingAxis = false;
    }

    // Update is called once per frame
    private void Update()
    {
        if (controller.getBehindBackInput() == 1)
        {
            if (controller.isMyturn() && !controller.isSkillUsing() && !usingAxis)
            {
                StopCoroutine("move");
                behindBack();
            }
            usingAxis = true;
        }
        else
        {
            usingAxis = false;
        }
    }
    private void behindBack()
    {
        controller.updateMovementLockStates();
        changeHand();
        controller.updateMovementLockStates();
    }

    private void changeHand()
    {
        controller.currentHand *= -1;
        controller.callEvent();
        animatorController.SetTrigger("BehindBack");
    }
}
