﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

[RequireComponent(typeof(Animator))]
[RequireComponent(typeof(Controller))]
[RequireComponent(typeof(Rigidbody2D))]
public class IAMovementScript : MonoBehaviour
{
    private float offsetDistance;
    private Animator animatorController;
    private Controller controller;
    private Rigidbody2D rb;
    private Transform playerTransform;

    void Start()
    {
        animatorController = GetComponent<Animator>();
        controller = GetComponent<Controller>();
        rb = GetComponent<Rigidbody2D>();
        setupAnimatorController();

        offsetDistance = (playerTransform.position - transform.position).magnitude + 0.5f;
    }

    private void Update()
    {
        Vector2 displacementFromTarget = playerTransform.position - transform.position;
        Vector2 directionToTarget = displacementFromTarget.normalized;
        Vector2 velocity = directionToTarget * controller.getSpeed();

        float distanceToTarget = displacementFromTarget.magnitude;

        if (distanceToTarget > offsetDistance)
        {
            animatorController.SetBool("Moving", true);
            rb.velocity = velocity;
        }
        else
        {
            animatorController.SetBool("Moving", false);
        }
    }

    private void setupAnimatorController()
    {
        animatorController.SetBool("Moving", false);
        animatorController.SetBool("Shooting", false);
    }

    public void setPlayerTransform(Transform player)
    {
        playerTransform = player;
    }
}
