﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

[RequireComponent(typeof(Rigidbody2D))]
[RequireComponent(typeof(Animator))]
[RequireComponent(typeof(Controller))]

public class MovementScript : MonoBehaviour
{
    private Rigidbody2D rb;
    private Animator animatorController;
    private Controller controller;

    // Use this for initialization
    void Start ()
    {
        rb = GetComponent<Rigidbody2D>();
        animatorController = GetComponent<Animator>();
        controller = GetComponent<Controller>();
        setupAnimatorController();
    }

    private void Update()
    {
        if (rb.velocity == Vector2.zero)
        {
            animatorController.SetBool("Moving", false);
        }
        else
        {
            animatorController.SetBool("Moving", true);
        }
    }
    private void FixedUpdate()
    {
        if (!controller.isMoving())
        {
            StartCoroutine("move");
        }
    }

    private IEnumerator move()
    {
        rb.velocity = new Vector2(controller.getHorizontalMovementInput(), controller.getVerticalMovementInput()) * controller.getSpeed();
        transform.rotation = rb.velocity.x <= 0 ? Quaternion.AngleAxis(180, Vector3.up) : Quaternion.AngleAxis(0, Vector3.up);
        yield return null;
    }

    private void setupAnimatorController()
    {
        animatorController.SetBool("Moving", false);
        animatorController.SetBool("Shooting", false);
    }

    public void moveToPosition(Transform transform)
    {
        rb.MovePosition(transform.position);
    }
}
