using System.Collections;
using System.Collections.Generic;
using UnityEngine;

[RequireComponent(typeof(Controller))]
[RequireComponent(typeof(Animator))]


public class RoubarBolaScript : MonoBehaviour
{
    private Animator animatorController;
    private Controller controller;
    private bool usingAxis;

    // Use this for initialization
    void Start ()
    {
        controller = GetComponent<Controller>();
        animatorController = GetComponent<Animator>();
        usingAxis = false;
    }

    // Update is called once per frame
    private void Update()
    {
        if (controller.getStealInput() == 1)
        {
            if (!controller.isMyturn() && !controller.isSkillUsing() && !usingAxis)
            {
                StopCoroutine("move");
                steal();
            }
            usingAxis = true;
        }
        else
        {
            usingAxis = false;
        }        
    }
    private void steal()
    {
        controller.updateMovementLockStates();
        animatorController.SetTrigger("Steal");
    }

    private void stealAttempt()
    {
        if ((controller.opponentHand + controller.currentHand == 0 ? Random.Range(0, 5) : 0) == 0)
        {
            animatorController.SetBool("BolaRoubada", true);
        }
        controller.updateMovementLockStates(); 
    }

    public virtual void OnDisable()
    {
        RoubarBolaBehaviour1.action -= stealAttempt;
    }

    public virtual void OnEnable()
    {
        RoubarBolaBehaviour1.action += stealAttempt;
    }
}
